<template>
  <TagsCategoriesPreferences></TagsCategoriesPreferences>
</template>

<script>
import {
  getPreferences as getPreferencesAction,
  getRestaurantPreferences as getRestaurantPreferencesAction,
  searchTags as searchTagsAction,
  searchRestaurantTags as searchRestaurantTagsAction,
  savePreferences as savePreferencesAction,
  saveRestaurantPreferences as saveRestaurantPreferencesAction,
  searchHostelCategories as searchHostelCategoriesAction,
  getHostelPreferences as getHostelPreferencesAction,
  saveHostelPreferences as saveHostelPreferencesAction,
  getTags as getTagsAction,
  getRestaurantTags as getRestaurantTagsAction,
  getAllHostelCategories as getAllHostelCategoriesAction
} from "@/actions/TagsCategoriesAction";
import TagsCategoriesPreferences from "@/components/Form/TagsCategoriesPreferences";
import {provideMethods, provideDatas} from "@/libs/genProvider";

const actionsByType = {
  POI: {
    search: searchTagsAction,
    getPreferences: getPreferencesAction,
    getTags: getTagsAction,
    save: savePreferencesAction
  },
  restaurant: {
    search: searchRestaurantTagsAction,
    getPreferences: getRestaurantPreferencesAction,
    getTags: getRestaurantTagsAction,
    save: saveRestaurantPreferencesAction
  },
  hostel: {
    search: searchHostelCategoriesAction,
    getPreferences: getHostelPreferencesAction,
    getTags: () => getAllHostelCategoriesAction().then(res => res.map(({id}) => id)),
    save: saveHostelPreferencesAction
  }
}

export default {
  name: "TagsPreferencesProvider",
  components: {TagsCategoriesPreferences},
  inject: ['user'],
  provide() {
    const provider = {};

    provideDatas(provider, "tagsPreferencesProvider", this, true);
    provideMethods(provider, "tagsPreferencesProvider", this);

    return provider;
  },
  props: {
    type: String,
    field: {
      default: null
    },
    show: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      preferences: [],
      tags: null,
      saved: true,
      foundResults: null,
      search: '',
      searchedButAlreadyPresent: null,
      shown: false
    }
  },
  methods: {
    searchTags(search) {
      actionsByType[this.type].search(search)
          .then(results => {
            const foundResults = [];
            for (const elem of results) {
              foundResults.push(elem);
            }
            this.foundResults = foundResults;
          })
    },
    onInputSearch(value) {
      this.foundResults = null;
      if (value.length > 0) {
        this.searchTags(value);
      } else {
        this.foundResults = this.tags;
      }
    },
    onInputClick(value) {
      if (value === "") {
        this.foundResults = this.tags;
      } else {
        this.onInputSearch(value);
      }
    },
    onClickOutsideInput() {
      this.foundResults = null;
    },
    addPreference(tag) {
      if (this.preferences.includes(tag)) {
        this.searchedButAlreadyPresent = tag
        setTimeout(() => {
          this.searchedButAlreadyPresent = null;
        }, 1000)
      }
      else {
        this.preferences.push(tag);
        this.saved = false;
      }
      this.foundResults = null;
      this.search = "";
    },
    removePreference(tag) {
      for (let i=0;i<this.preferences.length;i++) {
        if (this.preferences[i] === tag) {
          this.preferences.splice(i, 1);
          break;
        }
      }
      this.saved = false;
    },
    savePreferences() {
      if (this.saved)
        return;
      actionsByType[this.type].save(this.preferences).then(() => {
        this.saved = true;
      })
    }
  },
  async beforeMount() {
    if (actionsByType[this.type] === undefined)
      throw Error("Invalid type for preferences");
    this.shown = this.show;
    if (this.field) {
      this.preferences = this.field;
    }
    if (this.user.session) {
      for (const elem of await actionsByType[this.type].getPreferences().then(res => res.json())) {
        this.preferences.push(elem);
      }
      this.tags = await actionsByType[this.type].getTags();
    }
  },
  computed: {
    textByType() {
      return {
        POI: "étapes",
        restaurant: "restaurants",
        hostel: "hôtels"
      }[this.type]
    }
  }
}
</script>

<style scoped>

</style>